<?php
	/**
	 * A control that displays a SideNavigation for the entire site. Pages starting with '_' (underscore) are ignored.
	 * 
	 * @package Pomo_Website_Management_System
	 */
?>
<style>
	.SideMenuTitle
	{
		font-size: 1.2em;
	}
	.SideNavMenuL1
	{
		 margin-left: 5px;
	}
	.SideNavMenuL2
	{
		 margin-left: 10px;
	}
	.SideNavMenuL3
	{
		 margin-left: 10px;
	}

	A.SideMenuFolder, A.SideMenuFolder:link, A.SideMenuFolder:visited
	{
		text-decoration: underline;
		color: black;
		font-size: 0.8em;
	}
	A.SideMenuFolder:hover
	{
		text-decoration: underline;
		color: black;
	}

	A.SideMenuPage, A.SideMenuPage:link, A.SideMenuPage:visited
	{
		text-decoration: none;
		color: black;
		font-size: 0.8em;
	}
	A.SideMenuPage:hover
	{
		text-decoration: underline;
		color: black;
	}

	
</style>

<?php

	function PageOutput($_page, $level) 
	{
		if($_page == NULL || $_page->GUID == -1) 
		{
			return;			
		}

		if(isset($_page->name[0]) && $_page->name[0] == '_') 
		{
			return;
		}
		echo("<div class=\"SideNavMenuL".$level."\">\n");
		echo("<A class=\"SideMenuFolder\" HREF=\"".$_page->URL(true)."\">".$_page->displayname."</A>\n");
		$pages = $_page->subPages();


		foreach ($pages as $page) 
		{		
			# debug($page);
			if($page->displayname[0] != '_') 
			{
				# echo("<li><A class=\"SideMenuPage\" HREF=\"".$page->URL()."\">".$page->displayname."</A></li>\n");		
				PageOutput($page, $level+1);
			}

		} // for pages
		echo("");

		echo("</div>\n");
		
	} // FolderOutput

	$rootPage = $this->context->getPageByPath("");
	
	echo('<div class="SideMenuTitle">Navigation</div>');
	PageOutput($rootPage, 1);



?>