<?php

include_once("functions.inc");
////////////////////////////////////////////////////////////////////////
/**
 *	An abstract class that defines the functions that an executable PagePart must implement 
 *
 * @link        http://pomo.sourceforge.net for the latest version
 * @author	    Jason Suwala <jsuwala[at]gmail.com>
 * @copyright	Jason Suwala <jsuwala[at]gmail.com> - distributed under the GPL
 * 
 * @package Pomo_Website_Management_System
 * @version 0.1
 * @license http://www.opensource.org/licenses/gpl-license.php General Public License (GPL)
 * 
 */
////////////////////////////////////////////////////////////////////////
abstract class executablePagePart
{

   abstract public function execute(Context $_context, PagePart $_pagePart);
   abstract private function getContents();
   
}

////////////////////////////////////////////////////////////////////////
/**
 *	A PagePart is an executable part of a page - sometimes called a PlaceHolder 
 *
 *	Multiple PageParts can be associated with a Page. PageParts can be of many different types
 * 	such as images, HTML, and plain text. Complex pageParts might be
 * 	PageParts are different from Controls in that PageParts are usually database driven.
 *
 * @link        http://pomo.sourceforge.net for the latest version
 * @author	    Jason Suwala <jsuwala[at]gmail.com>
 * @copyright	Jason Suwala <jsuwala[at]gmail.com> - distributed under the GPL
 * 
 * @package Pomo_Website_Management_System
 * @version 0.1
 * @license http://www.opensource.org/licenses/gpl-license.php General Public License (GPL)
 * 
 */
////////////////////////////////////////////////////////////////////////
class PagePart 
{ 
  public $parentPage;
  public $GUID;
  public $name;
  public $type;
  public $sortOrdinal;
  public $context;
  
  public function PagePart($_parentPage, $_type, $_name, $_GUID, $_sortOrdinal,$_context)
  {
      $this->GUID = $_GUID;
      $this->name = $_name;
      $this->type = $_type; 
      $this->parentPage = $_parentPage;
      $this->sortOrdinal = $_sortOrdinal;
      $this->context = $_context;
  
  } // constructor
  
	/**
	 * Execute (display) this PagePart
	 * 
	 * @return bool TRUE if the execution went OK, FALSE otherwise.
	 */
	public function execute()
	{
		//echo("pagePart->Execute!");   
		$obj = $this->name;
		$meth = $this->type;
		$argArray = $this->context;


		$fn = $GLOBALS['pageparts_dir'].$this->type.".inc";
		include_once($fn);

		eval("\$obj = new \$meth();");
		eval("\$ret= \$obj->execute(\$argArray,\$this);");
		// print_r($obj);
		return $ret;
	} // Execute
  

	/**
	 * Saves this item to the database by creating a new entry, or update an existing one if it exists
	 * 
	 * @return bool returns TRUE if saved successfully, otherwise FALSE
	 */
	public function SaveToDatabase() 
	{

		$sql = "SELECT `GUID` FROM `PageParts` where (now() < Deleted or IsNull(Deleted)) and (ParentPage = '".$this->parentPage."')  and (Name = '".$this->name."')  and (type = '".$this->type."')"; 

		/* Connecting, selecting database */ 
		$link = mysql_connect("localhost", "phpwebsite", "phpwebsite") or die("Could not connect : " . mysql_error()); 
		// print "Connected successfully"; 
		mysql_select_db("myphpwebsite") or die("Could not select database myphpwebsite"); 

		$return = false;
		/* Performing SQL query */ 
		$result = mysql_query($sql) or die("PagePart Query failed : " . mysql_error()); 
		if($result && mysql_num_rows($result) > 0  )
		{
			// ----------------
			// -- the page exists in the database. let's update it
			$row = mysql_fetch_assoc($result);
			$return = $this->UpdateDatabase($link, $row["GUID"]);
		}
		else
		{
			// ----------------
			// -- page does not exist. let's create it
			$return = $this->InsertIntoDatabase($link);
		}

		mysql_close($link);
		return $return;
		
	} // SaveToDatabase

	private function UpdateDatabase($link, $PageGuid) 
	{

		$pipeline_name = $this->pipeline_name;
		
		$parentQuery = " parentPage = ".$this->parentPage;
		if($this->parentPage == "" || $this->parentPage == -1) 
		{
			$parentQuery = " parentPage = NULL";			
		}

		$sql = "UPDATE PageParts SET Name = `".$this->name."`, type = `".$this->type."`, ".$parentQuery.", SortOrdinal = `".$this->sortordinal." where GUID = ".$this->GUID.";";

		mysql_query($sql);
		return (mysql_affected_rows() == 1);
		
	} // UpdateDatabase
  
	private function InsertIntoDatabase($link) 
	{
		/*
		  $this->GUID = $_GUID;
		  $this->name = $_name;
		  $this->type = $_type; 
		  $this->parentPage = $_parentPage;
		  $this->sortOrdinal = $_sortOrdinal;
		  $this->context = $_context;
		*/
		
		$sql = "INSERT INTO PageParts (GUID, Name, type, parentpage, sortordinal) VALUES('".$this->GUID."', '".$this->name."', '".$this->type."','".$this->parentPage."', '".$this->sortOrdinal."');";

		mysql_query($sql) or die("Invalid insert: " . mysql_error()." <br> ".$sql);

		$id = mysql_insert_id();
		if($id == 0) { return false;}
		else 
		{
			 return true;
		}
		
	} // InsertIntoDatabase

} // class PagePart
?>
