<?php 

include_once("functions.inc");

////////////////////////////////////////////////////////////////////////
/**
 *	This class encapsulates all information about any user.  
 *
 * @link        http://pomo.sourceforge.net for the latest version
 * @author	    Jason Suwala <jsuwala[at]gmail.com>
 * @copyright	Jason Suwala <jsuwala[at]gmail.com> - distributed under the GPL
 * 
 * @package Pomo_Website_Management_System
 * @version 0.1
 * @license http://www.opensource.org/licenses/gpl-license.php General Public License (GPL)
 * 
 */
////////////////////////////////////////////////////////////////////////
class User 
{ 

	public $GUID;	// string
	public $context;	 // object

	public $username;
	public $password_hash;

	public $accesslevel; // integer

	public $email; // string

	public $loggedIn; // boolean

	/**
	 * The constructor
	 * 
	 * @param Context $_context the current context
	 */
	public function User(Context $_context)
	{
		$this->context = $_context;
		$this->loggedIn = false;
		// session_start();

	} // constructor

	public function loadFromDBRow($row) 
	{
		$this->GUID = $row["UserIndex"];

		$this->username = $row["username"];
		$this->password_hash = $row["password"];
		
		$this->accesslevel = $row["accesslevel"];
		$this->email = $row["email"];

	} // loadFromDBRow

	/**
	 * Initialize a user based on a username
	 * 
	 * @param string $_username the username to find
	 * 
	 * @return bool TRUE if the user was found and initialized, FALSE otherwise
	 */
	public function InitFromDatabase($_username) // $_username is a string
	{
		$sql = "SELECT `UserIndex`, `username`, `password`, `accesslevel`, `email` FROM `users` where (now() < Deleted or IsNull(Deleted)) and (`username` = '".$_username."')"; 

		// echo("<br>".$sql."<br>");

		/* Connecting, selecting database */ 
		$link = mysql_connect("localhost", "phpwebsite", "phpwebsite") or die("Could not connect : " . mysql_error()); 
		// print "Connected successfully"; 
		mysql_select_db("myphpwebsite") or die("Could not select database myphpwebsite"); 

		/* Performing SQL query */ 
		$result = mysql_query($sql) or die("Query failed : " . mysql_error()); 
		if($result && mysql_num_rows($result) > 0  ) 
		{
			$row = mysql_fetch_assoc($result); 
		
			$this->loadFromDBRow($row);
			
			return true;
		}
		else
		{
			return false;
		}

	} // InitFromDatabase

	/**
	 * Logs a user into the system
	 */
	public function Login($_username, $_password)
	{
		$_username = trim($_username);
		// check username
		if(strcasecmp($_username, $this->username) == 0 ) 
		{
			
			if(strcasecmp($_password, $this->password_hash) == 0)
			{				
				// session_start(); - session already started in Context
				$_SESSION['username'] = $_username; 
				$_SESSION['password_hash'] = $_password; 
				$this->loggedIn = true;
				return true;
			}	
			else
			{
				return false;
			}
		}
		else
		{
			return false;
		}
		return false;
	}

	/**
	 * logs the currently active user out
	 */
	public function Logout() 
	{
		unset($_SESSION['username']);
		unset($_SESSION['password_hash']);
		$this->loggedIn = false;
		
	} // Logout

	public function Logoff() 
	{
		Logout();
		
	} // Logoff

	public function LoadAndLogin($_username, $_password) 
	{
		if( isset($_username) && isset($_password)) 
		{
			$init = $this->InitFromDatabase($_username);
			
			if($init === true) 
			{				
				return $this->Login($_username, $_password);				
			}
			return false;			
		}
		else
		{
			return false;
		} 
		
	} // LoadAndLoginFromSession

	public function LoadAndLoginFromSession() 
	{
		// session_start();
		// debug($_SESSION['username']."x".$_SESSION['password_hash']);
		
		if( isset($_SESSION['username']) && isset($_SESSION['password_hash'])) 
		{
			$init = $this->InitFromDatabase($_SESSION['username']);
			if($init === true) 
			{
				return $this->Login($_SESSION['username'], $_SESSION['password_hash']);				
			}
			return false;			
		}
		else
		{
			return false;
		} 
		
	} // LoadAndLoginFromSession

} // class user

?>