<?php
include_once("pipelineBase.class.inc");
////////////////////////////////////////////////////////////////////////
/**
 *	A pipeline class that publishes all items submitted immediately  
 *
 * @link        http://pomo.sourceforge.net for the latest version
 * @author	    Jason Suwala <jsuwala[at]gmail.com>
 * @copyright	Jason Suwala <jsuwala[at]gmail.com> - distributed under the GPL
 * 
 * @package Pomo_Website_Management_System
 * @version 0.1
 * @license http://www.opensource.org/licenses/gpl-license.php General Public License (GPL)
 * 
 */
////////////////////////////////////////////////////////////////////////
class PublishImmediately extends pipelineBase
{
	/**
	 * submits data with a given guid to the start of the pipeline
	 * @param string $_guid the guid of the data being submitted
	 * @param object $_data any object that will be submitted to the start 
	 * @return bool returns TRUE if successfully submitted, FALSE if not
	 */	
	public function submitToStart($_guid, $_data)
	{
		$result = false;
		if($this->getObjectInPipeline($_guid) == NULL) {
			// if the guid doesn't exist, insert it

			$sql = "Insert into PageData (`GUID`, `status`, `Data`) Values (";
			$sql = $sql."'".$_guid."', ";
			$sql = $sql."'PUBLISHED', ";
			$sql = $sql."'".serialize(addslashes($_data))."');";
			# $sql = $sql."'".($_data)."');";
			/* Performing SQL query */ 
			// echo("<br>PublishImmediately Insert SQL: ".$sql);
			// do the query
			$result = $this->context->db->query($sql);			
			// $result = mysql_query($sql) or die("insert to pipeline Query failed : " . mysql_error().' guid='.$_guid); 

			// print_r("RESULT: ".$result);
		}
		else
		{
			// the guid already exists, so update the existing item
			$sql = "UPDATE PageData SET Data = ";
			$sql = $sql."'".serialize($_data)."' WHERE GUID = ";
			# $sql = $sql."'".($_data)."' WHERE GUID = ";
			$sql = $sql."'".$_guid."'; ";

			# debug("<br>PublishImmediately Update SQL: ".$sql);

			# debug(serialize($_data)." XXX ".unserialize(serialize($_data)));
			$result = $this->context->db->query($sql);
			// $result = mysql_query($sql) or die("update pipeline Query failed : " . mysql_error()); 

			// print_r("RESULT: ".$result);

		}
		
		if($result)
			return true;
		else
			return false;
	} // submitToStart
   
   /**
    * called when the pipeline is processed
    */
   public function processPipeline()
   {
   }
   
   /**
    * gets the status of an object in the pipeline
    * @return array returns an array: array(["status"]=> Pending|Published; ["description"]=> extended description)
    
    * @todo should return status=> "ERROR" if the GUID does not exist
    */
   public function getStatus($GUID)
   {
   		$ret = array("status"=>"PUBLISHED","description"=>"Published and Live on the Internet");
		return $ret;
   }
   
   /**
    * returns the data associated with a GUID
    * @param string $GUID the guid to get the data for
    * @return object returns the object data, or NULL if not successful
    */
   public function getObjectInPipeline($GUID)
   {
		
		if (gettype($GUID)!= 'string')
		{
			echo('<h1>type: '.gettype($GUID));
		}
		$sql = "SELECT `Data` FROM `PageData` WHERE GUID='".$GUID."'"; 

		 //echo("<br>".$sql."<br>");
		// do the query
		$result = $this->context->db->query($sql);
		if($this->context->db->numRows() > 0 ) 
		{
			$row = $this->context->db->getNext(); 
			// echo("count: ".mysql_num_rows($result));
			// print_r($row);
			$obj = unserialize(stripslashes($row["Data"]));
			# $obj = $row["Data"];

			# debug($obj);

			if ($obj === FALSE) {
				echo('error unserializing guid '.$GUID.'<br>');
				return NULL; // error unserializing
			}
			return $obj;
		}// if there is data
	
	
		// nothing found
		return NULL;
	
   
   }
} // class PublishImmediately
?>