<?php
////////////////////////////////////////////////////////////////////////
/**
 *	index.php - the main entry point into the website. 
 *				This page creates a new Context object, and then executes the current page
 *				if it is valid. This file will try to see if a file exists
 *				on the webserver that should first be executed. If not, it will load up
 *				a Context and execute the page that was requested.
 *
 * @link        http://pomo.sourceforge.net for the latest version
 * @author	    Jason Suwala <jsuwala[at]gmail.com>
 * @copyright	Jason Suwala <jsuwala[at]gmail.com> - distributed under the GPL
 * 
 * @package Pomo_Website_Management_System
 * @version 0.1
 * @license http://www.opensource.org/licenses/gpl-license.php General Public License (GPL)
 * 
 */
////////////////////////////////////////////////////////////////////////
	/**
	 *  
	 * @todo ----------- GLOBAL TO-DO LIST ------------ 
	 * @todo auto-generated summary template of all child pages
	 * @todo Attachment Page Part
	 * @todo make caching object
	 * @todo make work with non-anonymous users (per-page user access)
	 * @todo auto-generated summary template that can summarize info from all over the place
	 * @todo control that can generate a local Table of Contents (from [A name=""] tags in a HTMLArea)
	 * @todo some way of having a folksonomy of pages, where the navigation is based on that folksonomy
	 * @todo some sort of tie-in with MS Word as the authoring environment
	 * 			- http://wvware.sourceforge.net/index.html
	 * 			- http://buzz.blogger.com/bloggerforword.html
	 * @todo ----------- GLOBAL TO-DO LIST ------------ 
	 */
	
	include_once("core/config.inc");
	include_once("core/functions.inc");

	// try to see if the requested file exists on the web server
	// @TODO make this work with other web servers
	$apache_info = apache_lookup_uri($_SERVER['REQUEST_URI']);
	// core_process_file should point to this file
	$process_file = $GLOBALS['core_process_file'];

	if (file_exists($apache_info->filename) && !is_dir($apache_info->filename) && $process_file != $apache_info->filename) 
	{
		// Perform Apache sub-request and die			
		OutputMimeHeader($_SERVER['REQUEST_URI']);
		virtual($_SERVER['REQUEST_URI']);
		die();
	}
	else
	{
		// if the requested file does not exist on the web server, load the system up
		// and see if we can process it.
		include_once("core/Context.class.inc");
		include_once("core/db.class.inc");
		include_once("core/page.class.inc");
    	include_once("core/attachment.class.inc");
		include_once("core/user.class.inc");
		include_once("core/TemplateExecuter.class.inc");
		include_once("core/pipelines/pipelineBase.class.inc");
		
    	$currentContext = new Context($_SERVER['QUERY_STRING']);
    
		if ($currentContext->isValid)
		{			
			if($currentContext->currentPage->GUID != -1 ) 
			{				
				$currentContext->currentPage->execute();	
			}	
			else
			{
				// if the Context's currentPage isn't valid, we need to output a server error.
				OutputError(500);
			}			
		}
		else
		{
			// if the context isn't valid, output a 404 not found error.
			OutputError(404);
		}
	 }
?>
