<?php

 ////////////////////////////////////////////////////////////////////////
/**
 *	a pagepart that will display an Attachment.  
 *
 * @link        http://pomo.sourceforge.net for the latest version
 * @author	    Jason Suwala <jsuwala[at]gmail.com>
 * @copyright	Jason Suwala <jsuwala[at]gmail.com> - distributed under the GPL
 * 
 * @package Pomo_Website_Management_System
 * @version 0.1
 * @license http://www.opensource.org/licenses/gpl-license.php General Public License (GPL)
 * 
 *	@todo Attachments are currently (Oct. 2005) being pushed into the Core. This PagePart will not last long. 
 *
 **/
////////////////////////////////////////////////////////////////////////
class AttachmentPagePart extends executablePagePart
{
	private $context;
	private $pagePart;

	/* image attributes: src title align border width height class usemap*/
	/* user editable attributes: src title href */

	public function execute(Context $_context, PagePart $_pagePart)
	{
		$this->context = $_context;
		$this->pagePart = $_pagePart;

		switch($this->context->ViewMode)
		{
			case "view": $this->View();
			break;
		
			case "edit": $this->Edit();
			break;
		} // switch
	} // execute
   
   
   private function getContents()
   {
		$page = $this->context->currentPage;
		
		$attachments = $page->attachments();
		
		return $attachments;
   } // getContents
   
	private function View()
	{
		// nothing to view. Use the AttachmentDisplay Control	
		
	} // View
	
   
	private function Edit()
	{
		echo('<p>');
		$att = new Attachment($this->context);
		
		if(! req_isSet('add_new'))
		{
			$att->attachment_id = CreateGUID();
			$att->parentPageID = $this->context->currentPage->GUID;
			$att->name = ''; // the url name
			$att->displayname = ''; // the human readable title 		
			$att->type; // the type of the attachment
			$att->attributes = array(); // array of attributes
			$att->sortOrdinal = 1; // integer
		}
		else
		{
			$att->attachment_id = $_REQUEST['att_id'];
			$att->parentPageID = $this->context->currentPage->GUID;
			$att->name = $_REQUEST['att_name'];; // the url name
			$att->displayname = $_REQUEST['att_display'];; // the human readable title 		
			$att->type = ''; // the type of the attachment
			$att->attributes = array('src'=>'dsc00753.jpg'); // array of attributes
			$att->sortOrdinal = 1; // integer
			
			$att->SaveToDatabase();
		}
		
		?>
		<form action="<?php echo $_SERVER['REQUEST_URI']; ?>" method="post" enctype="multipart/form-data">
		<table>
		<tr><td>Browse for local attachment:</td><td><input type="file" name="uploadfile[]"> max size: <?php echo(ini_get('upload_max_filesize')); ?></td></tr>
		<tr><td>URL Name:</td><td><input type="text" name="att_name"></td></tr>
		<tr><td>Title:</td><td><input type="text" name="att_display"></td></tr>
		</table>
		<input type="hidden" name="att_id" value="<?php echo($att->attachment_id) ?>">
		<input type="submit" name="add_new" value="save">	
		</form>
		<?php
			
	} // Edit



} // class Image

?>
