<?php

////////////////////////////////////////////////////////////////////////
/**
 *	A PagePart that displays HTML when in "VIEW" mode, or has an in-place
 *	editor when in "EDIT" mode  
 *
 * @link        http://pomo.sourceforge.net for the latest version
 * @author	    Jason Suwala <jsuwala[at]gmail.com>
 * @copyright	Jason Suwala <jsuwala[at]gmail.com> - distributed under the GPL
 * 
 * @package Pomo_Website_Management_System
 * @version 0.1
 * @license http://www.opensource.org/licenses/gpl-license.php General Public License (GPL)
 * 
 */
////////////////////////////////////////////////////////////////////////
class ContentArea extends executablePagePart
{
	private $context;
	private $pagePart;
	public function execute(Context $_context, PagePart $_pagePart)
	{
		$this->context = $_context;
		$this->pagePart = $_pagePart;

		switch($this->context->ViewMode)
		{
			case "view": $this->View();
			break;
		
			case "edit": $this->Edit();
			break;
		} // switch
	} // execute
   
   
   private function getContents()
   {
   		$obj = $this->context->currentPipeline->getObjectInPipeline($this->pagePart->GUID);
		if ($obj === NULL) {
			return "";		 
		}
		else
		{
			# debug($obj);
			return $obj;
		}
   } // getContents
   
	private function View()
	{
		$contentData = $this->getContents();
		// note: the non-array version is here only for backwards compatability.
		//       - it should be removed after all pages have been updated to this new model.
		if (is_array($contentData))
		{
			echo($contentData['html']);
		}
		else
		{
			echo($contentData);
		}
	} // View
   
	private function Edit()
	{
		$editorname = "editor".$this->pagePart->GUID; 
		// see if we need to save the submitted HTML
		if (isset($_REQUEST[$editorname]) && $_REQUEST[$editorname]  != "")
		{
		   
		   $dataToSave = $_REQUEST[$editorname];
		   # debug ("saving html: ".$dataToSave);
		   $contentData = array('html' => $dataToSave);
		   $this->context->currentPipeline->submitToStart($this->pagePart->GUID, $contentData);

			$target = get_config_url('toggle_edit_live_url');
			if(isset($_REQUEST['submit_button']) && $_REQUEST['submit_button'] == 'save and exit') 
			{
				header("Location: ".$target);
				die();	
			} // if save and exit
	
		} // if save the submitted value

		?>
		<script type="text/javascript">
		  _editor_url = "/pageParts/HTMLArea/";
		  _editor_lang = "en";
		</script>

		<!-- load the main HTMLArea file -->
		<script type="text/javascript" src="/pageParts/HTMLArea/htmlarea.js"></script>

		<script type="text/javascript">
		  HTMLArea.loadPlugin("ContextMenu");
		  HTMLArea.loadPlugin("TableOperations");

		  function initDocument() {
			var editor = new HTMLArea("editor");
			editor.registerPlugin(ContextMenu);
			editor.registerPlugin(TableOperations);
			editor.height = "auto";
			editor.generate();
		  }

		function winClose()
		{
			if (confirm("Are you sure you want to navigate away from this page?"))
			{
				window.close();
			}
			return false;
		}
			  
		</script>

		<img src="/images/spacer.gif" width="1" height="1" onload="initDocument();">
		<form action="<?php echo $_SERVER['REQUEST_URI']; ?>" method="post">
		<textarea id="editor" name="<?php echo $editorname ?>" style="height: 20em; width: 80%;">
	<?php 	
		   $this->View();
	?>
		</textarea>
		<input type="submit" name="submit_button" value="save"> <br>
		<input type="submit" name="submit_button" value="save and exit">
		</form>   	
		<?php
   } // Edit

} // class ContentArea

?>
