<?php

////////////////////////////////////////////////////////////////////////
/**
 *	A pagepart that will display an Image. It can be configured to display a thumbnail of an images 
 *
 * @link        http://pomo.sourceforge.net for the latest version
 * @author	    Jason Suwala <jsuwala[at]gmail.com>
 * @copyright	Jason Suwala <jsuwala[at]gmail.com> - distributed under the GPL
 * 
 * @package Pomo_Website_Management_System
 * @version 0.1
 * @license http://www.opensource.org/licenses/gpl-license.php General Public License (GPL)
 * 
 */
////////////////////////////////////////////////////////////////////////
class Image extends executablePagePart
{
	private $context;
	private $pagePart;

	/* image attributes: src title align border width height class usemap*/
	/* user editable attributes: src title href */

	public function execute(Context $_context, PagePart $_pagePart)
	{
		$this->context = $_context;
		$this->pagePart = $_pagePart;

		switch($this->context->ViewMode)
		{
			case "view": $this->View();
			break;
		
			case "edit": $this->Edit();
			break;
		} // switch
	} // execute
   
   
   private function getContents()
   {
   		$obj = $this->context->currentPipeline->getObjectInPipeline($this->pagePart->GUID);
		if ($obj === NULL) {
			return "";		 
		}
		else
		{
			# debug($obj);
			return $obj;
		}
   } // getContents
   
	private function View()
	{
		$imgdata = $this->getContents();
		if($imgdata == "" || ! is_array($imgdata)) 
		{
			echo("no image to show");
		}
		else
		{
			if ($imgdata['src'] != '')
			{
				if ($imgdata['thumb_linkToLarger'])
				{
					echo('<a href="'.$imgdata['src'].'" target="'.$imgdata['href_target'].'">');
				}
				else if($imgdata['href'] != '') 
				{
					echo('<a href="'.$imgdata['href'].'" target="'.$imgdata['href_target'].'">');
				}
				
				if(isset($imgdata['generate_thumb']) && $imgdata['generate_thumb'] && isset($imgdata['thumb_MaxWidth']) && is_numeric($imgdata['thumb_MaxWidth']) && isset($imgdata['thumb_MaxHeight']) && is_numeric($imgdata['thumb_MaxHeight']))
				{
					
					echo('<img src="'.get_config_url('image_showthumb_url', array('f'=>$imgdata['src'], 'w'=>$imgdata['thumb_MaxWidth'], 'h'=>$imgdata['thumb_MaxHeight'])).'" title="'.$imgdata['title'].'" alt="'.$imgdata['title'].'" align="'.$imgdata['align'].'" border="'.$imgdata['border'].'" class="'.$imgdata['class'].'">');
						
				}
				else
				{				
					echo('<img src="'.$imgdata['src'].'" title="'.$imgdata['title'].'" alt="'.$imgdata['title'].'" align="'.$imgdata['align'].'" border="'.$imgdata['border'].'" class="'.$imgdata['class'].'">');
				}
	
				if($imgdata['href'] != '' || $imgdata['thumb_linkToLarger']) 
				{
					echo('</a>');
				}
			}
			/*
			if (isset($imgdata['generate_thumb']) && $imgdata['generate_thumb'])
			{
				echo("Thumb: ".$imgdata['generate_thumb']."<br>");
				echo("Thumb link to larger: ".$imgdata['thumb_linkToLarger']."<br>");
				echo("Max Width: ".$imgdata['thumb_MaxWidth']."<br>");
				echo("Max Height: ".$imgdata['thumb_MaxHeight']."<br>");
			}
			*/

		
		}
	} // View
	
	private function removeImage($imgFN)
	{
		$img_FN_full = $GLOBALS['image_upload_dir'].basename($imgFN);
		if(file_exists($img_FN_full) && is_file($img_FN_full) && ! is_dir($img_FN_full))
		{
			unlink($img_FN_full);
		}
	} // removeImage
   
   
   private function Edit_HandleImageUpload()
   {
			   	
   	
   } // Edit_HandleImageUpload
   
   
	private function Edit()
	{
		$imagename = "image".$this->pagePart->GUID; 
		$img_src = '';
		$img_toRemove = '';
		$img_thumbYN = false;
		$img_thumbLinkToLarger = false;
		$img_thumbMaxWidth = '';
		$img_thumbMaxHeight= '';
		// see if we need to save the submitted HTML
		if (req_isSet($imagename) && $_POST[$imagename]  == "1")
		{
		   // deal with the uploaded file
		   if($_FILES['uploadfile']['error'][0] != 4)
		   {		   		
		   		$uploadedFN = $_FILES['uploadfile']['tmp_name'][0];
		   		$imgFN = basename($_FILES['uploadfile']['name'][0]);
		   		
				// check to make sure it was an image uploaded
				$imageinfo = getimagesize($uploadedFN);
				if ($imageinfo !== false) 
				{
					// it was an image that was uploaded
					//  -- remove existing image
					$this->removeImage($_POST[$imagename.'_src']);
					$endplacedir = $GLOBALS['image_upload_dir'];
					$end_fn = $endplacedir.'/'.$imgFN;
					if (move_uploaded_file($uploadedFN, $end_fn))
					{
						# echo('File upload succeeded<p>');
						$img_src = $GLOBALS['image_upload_url'].$imgFN;						
					}
					else
					{
						echo('File upload failed<p>');
					}
					
				} 
				else
				{
					echo('Error: the uploaded file ""'.basename($imgFN).'" is not an image file<p>');
				}		   		   				
		   }
		   else
		   {
				# echo("no new image uploaded.<p>");
		   }
		   
			// load up the imgdata from the posted data
			if ($img_src == '')
			{
			  		$img_src = $_POST[$imagename.'_src'];
			}
			if (isset($_REQUEST[$imagename.'_thumbYN']))
			{
				$img_thumbYN = true;
			}
			else
			{
				$img_thumbYN  = false;
			}
			if (isset($_REQUEST[$imagename.'_thumbLinkToLarger']))
			{
				$img_thumbLinkToLarger = true;
			}
			else
			{
				$img_thumbLinkToLarger = false;
			}				
			
			$img_thumbMaxWidth = $_REQUEST[$imagename.'_thumbMaxWidth'];
			$img_thumbMaxHeight = $_REQUEST[$imagename.'_thumbMaxHeight'];
			$img_title = $_REQUEST[$imagename.'_title'];
			$img_border = $_REQUEST[$imagename.'_border'];
			$img_align = $_REQUEST[$imagename.'_align'];
			$img_class = $_REQUEST[$imagename.'_class'];
			$img_href = $_REQUEST[$imagename.'_href'];			
			$img_href_target = $_REQUEST[$imagename.'_href_target'];
			
			// remove the existing file		   
		   if(isset($_REQUEST[$imagename.'_remove']) && $_REQUEST[$imagename.'_remove'] == '1')
		   {
		   		$this->removeImage($_POST[$imagename.'_src']);
		   		$img_src = '';
		   		$img_title = '';
		   		$img_border = '';
		   		$img_align = '';
		   		$img_class = '';
		   		$img_href = '';
		   		$img_href_target = '';
		   		$img_thumbYN = false;
		   		$img_thumbLinkToLarger = false;
		   		$img_thumbMaxWidth = 0;
		   		$img_thumbMaxHeight = 0;
		   				   		
		   }
		   

		   $imgdata = array('src' => $img_src, 
							'title' => $img_title,
			    			'border' => $img_border,
						    'align' => $img_align,
							'class' => $img_class,
			   			    'href' => $img_href,
							'href_target' => $img_href_target,
							'generate_thumb' => $img_thumbYN,
							'thumb_linkToLarger' => $img_thumbLinkToLarger,
							'thumb_MaxWidth' => $img_thumbMaxWidth,
							'thumb_MaxHeight' => $img_thumbMaxHeight
							);

		   // save it to the pipeline
		   $this->context->currentPipeline->submitToStart($this->pagePart->GUID, $imgdata);

			$target = get_config_url('toggle_edit_live_url');
			if(isset($_POST['submit_button']) && $_POST['submit_button'] == 'save and exit') 
			{
				header("Location: ".$target);
				die();	
			} // if save and exit
	
		} // if save the submitted value

		$imgdata = $this->getContents();

		?>
		<form action="<?php echo $_SERVER['REQUEST_URI']; ?>" method="post" enctype="multipart/form-data">
		<b>Image Placeholder:</b><br>		
		
		<input type="hidden" name="<?php echo($imagename); ?>_src" value="<?php echo($imgdata['src']); ?>"><br>
		Upload new image: <input type="file" name="uploadfile[]"> max size: <?php echo(ini_get('upload_max_filesize')); ?><br>
		<input type="checkbox" name="<?php echo($imagename); ?>_remove" id="<?php echo($imagename); ?>_remove" value="1"><label for="<?php echo($imagename); ?>_remove">remove the existing image</label> <br>
		
		
		
		<strong>image attributes</strong><br>
		<table>
		<tr><td>Title:</td><td><input type="text" name="<?php echo($imagename); ?>_title" value="<?php echo($imgdata['title']); ?>"></td></tr>
		<tr><td>Align to text:</td><td>

   <input type="text" name="<?php echo($imagename); ?>_align" value="<?php echo($imgdata['align']); ?>"></td></tr>
		<tr><td>CSS Class:</td><td> <input type="text" name="<?php echo($imagename); ?>_class" value="<?php echo($imgdata['class']); ?>"></td></tr>
		<tr><td>border:</td><td> <input type="text" name="<?php echo($imagename); ?>_border" value="<?php echo($imgdata['border']); ?>"></td></tr>
		<tr><td>link(HRef):</td><td> <input type="text" name="<?php echo($imagename); ?>_href" value="<?php echo($imgdata['href']); ?>"></td></tr>
		<tr><td>link(target):</td><td> <input type="text" name="<?php echo($imagename); ?>_href_target" value="<?php echo($imgdata['href_target']); ?>"></td></tr>
		</table>
		<strong>Thumbnail image properties</strong><br>
		
  <input type="checkbox" name="<?php echo($imagename); ?>_thumbYN" value="true" id="<?php echo($imagename); ?>_cbthumbYN" <?php if($img_thumbYN) echo('CHECKED'); ?>  />
  <label for="<?php echo($imagename); ?>_cbthumbYN">Generate thumbnail</label><br>
  <input type="checkbox" name="<?php echo($imagename); ?>_thumbLinkToLarger" value="true" id="<?php echo($imagename); ?>_cbthumbLinkToLarger" <?php if($img_thumbLinkToLarger) echo('CHECKED'); ?>/>
  <label for="<?php echo($imagename); ?>_cbthumbLinkToLarger">Link to Full-Size Image</label>
  <br>
Thumbnail maximum width: <input type="text" name="<?php echo($imagename); ?>_thumbMaxWidth" value="<?php echo($img_thumbMaxWidth); ?>">
<br>
Thumbnail maximum height: <input type="text" name="<?php echo($imagename); ?>_thumbMaxHeight" value="<?php echo($img_thumbMaxHeight); ?>">

		<input type="hidden" name="<?php echo($imagename); ?>" value="1">
		
		<br>
		<input type="submit" name="submit_button" value="save"> <br>
		<input type="submit" name="submit_button" value="save and exit">
		</form> 
		<p><?php $this->View(); ?>  	
		<?php
   } // Edit



} // class Image

?>
