<?php
	// this template takes in 3 parameters - all of which are required
	// f: the filename to make a thumbnail of
	// w: the maximim width of thumbnail to create
	// h: the maximum height of thumbnail to create
	function OutputResampledJPEG($sourcefile, $forcedwidth, $forcedheight, $imgcomp)
	{
		$g_imgcomp=100-$imgcomp;
		$g_srcfile=$sourcefile;		
		$g_fw=$forcedwidth;
		$g_fh=$forcedheight;
		if(file_exists($g_srcfile))
		{
			$g_is=getimagesize($g_srcfile);
			if(($g_is[0]-$g_fw)>=($g_is[1]-$g_fh))
			{
				$g_iw=$g_fw;
				$g_ih=($g_fw/$g_is[0])*$g_is[1];
			}
			else
			{
				$g_ih=$g_fh;
				$g_iw=($g_ih/$g_is[1])*$g_is[0]; 
			}
			
			$img_src=imagecreatefromjpeg($g_srcfile);
			$img_dst=imagecreatetruecolor($g_iw,$g_ih);
			imagecopyresampled($img_dst, $img_src, 0, 0, 0, 0, $g_iw, $g_ih, $g_is[0], $g_is[1]);
			// output to stream
			header("Content-type: " . image_type_to_mime_type(IMAGETYPE_JPEG));
			imagejpeg($img_dst, "", $g_imgcomp);
			imagedestroy($img_dst);
			return true;
		}
		else
			return false;
	}	

	function OutputResampledGIF($sourcefile, $forcedwidth, $forcedheight)
	{
		$g_srcfile=$sourcefile;		
		$g_fw=$forcedwidth;
		$g_fh=$forcedheight;
		if(file_exists($g_srcfile))
		{
			$g_is=getimagesize($g_srcfile);
			if(($g_is[0]-$g_fw)>=($g_is[1]-$g_fh))
			{
				$g_iw=$g_fw;
				$g_ih=($g_fw/$g_is[0])*$g_is[1];
			}
			else
			{
				$g_ih=$g_fh;
				$g_iw=($g_ih/$g_is[1])*$g_is[0]; 
			}
			
			$img_src=imagecreatefromgif($g_srcfile);
			$img_dst=imagecreatetruecolor($g_iw,$g_ih);
			imagecopyresampled($img_dst, $img_src, 0, 0, 0, 0, $g_iw, $g_ih, $g_is[0], $g_is[1]);
			// output to stream
			header("Content-type: " . image_type_to_mime_type(IMAGETYPE_GIF));
			imagegif($img_dst);
			imagedestroy($img_dst);
			return true;
		}
		else
			return false;
	}	



	##################################################
	# MAIN
	# 
	// make sure there are 3 parameters - f: the image filename, w: the image max width, or h: the image max height
	if(req_isSet('f') && req_isSet('w') && req_isSet('h'))
	{
		$imageFN = $GLOBALS['image_upload_dir'].basename($_REQUEST['f']);
		if(file_exists($imageFN))
		{
			// check to make sure it was an image 
			$imageinfo = getimagesize($imageFN);
			if ($imageinfo !== false) 
			{
				switch($imageinfo['mime'])
				{
					case 'image/jpeg':	
						OutputResampledJPEG($imageFN,$_REQUEST['w'], $_REQUEST['h'], 40 );
						exit;
						break;	
					case 'image/gif':
						OutputResampledGIF($imageFN,$_REQUEST['w'], $_REQUEST['h']);
						exit;
						break;
				} // switch the mime time of the image
			}
		} // if file exists
	} // if file param set
	
	// base64-encoded error image in GIF format
	// this image is a single pixel transparent gif
	header('Content-type: image/gif');
	echo base64_decode('R0lGODlhAQABAID/AMDAwAAAACH5BAEAAAAALAAAAAABAAEAQAEBMgA7');
	exit;
	
?>
